<script lang="ts">
import Vue from 'vue';
import { IsMobileMixin } from '~/mixins';
import { CtfCustomPage, CtfEntry, CtfLandingGrid } from '~/models';
import type { PropType } from 'vue';

export default Vue.extend({
  mixins: [IsMobileMixin],
  props: {
    data: {
      type: Object as PropType<CtfLandingGrid>,
      required: false,
      default() {
        return {};
      },
    },
  },
  data() {
    return {
      cards: [],
    };
  },
  async fetch() {
    const path = this.$route.path.endsWith('/')
      ? this.$route.path
      : `${this.$route.path}/`;

    const childPages: CtfEntry<CtfCustomPage>[] =
      await this.$contentfulService.getLandingChildren(path);

    this.cards = childPages.map((card) => {
      if (card.fields.date) {
        // Format the date in the 'Month Day, Year' format
        const formattedDate = this.formatDate(card);

        return { ...card.fields, date: formattedDate };
      }

      return { ...card.fields };
    });
  },
  mounted() {
    if (!this.cards.length && this.data.cards) {
      this.cards = [...this.data.cards]
        .sort(function (a, b) {
          if (!a.fields.date || !b.fields.date) {
            return 0;
          }
          return a.fields.date < b.fields.date
            ? 1
            : a.fields.date > b.fields.date
              ? -1
              : 0;
        })
        .map((card) => {
          let formattedDate = '';
          if (card.fields.date) {
            formattedDate = this.formatDate(card);
          }
          return { ...card.fields, date: formattedDate };
        });
    }
  },
  methods: {
    formatDate(card) {
      const [dateWithoutTime] = card.fields.date.split('T');
      const date = new Date(dateWithoutTime.replace(/-/g, '/'));

      const month = date.toLocaleString('en-US', { month: 'long' });
      const day = date.getDate();
      const year = date.getFullYear();
      return `${month} ${day}, ${year}`;
    },
  },
});
</script>

<template>
  <div class="wrapper">
    <div
      class="landing-grid"
      :style="{
        'grid-template-columns': `repeat(${
          isMobile ? '1' : data.columns
        }, 1fr)`,
      }"
    >
      <a
        v-for="card in cards"
        :key="card.header"
        class="landing-card"
        :href="card.slug"
        :data-ga-name="card.header"
        data-ga-location="body"
      >
        <SlpTypography v-if="card.date" variant="body1"
          >{{ card.date }}
        </SlpTypography>
        <SlpTypography variant="heading5-bold">{{ card.header }}</SlpTypography>
        <SlpTypography variant="body3">{{ card.description }}</SlpTypography>
        <SlpIcon name="arrow-right" variant="product" size="sm" />
      </a>
    </div>
  </div>
</template>

<style lang="scss" scoped>
.landing-grid {
  display: grid;
  margin-top: 24px;
  grid-template-columns: 1fr;
  gap: 16px;

  @media (min-width: $breakpoint-lg) {
    grid-template-columns: repeat(4, 1fr);
    gap: 32px;
  }

  .landing-card {
    cursor: pointer;
    display: flex;
    color: $color-text-300;
    flex-direction: column;
    gap: 16px;
    padding: 24px;
    justify-content: space-between;
    background-color: $color-surface-800;
    min-height: 250px;
    border-radius: 4px;
    transition: all 0.3s;

    &:hover {
      border-radius: 4px 4px 90px 4px;
      background: linear-gradient(
        93.83deg,
        rgba(199, 177, 254, 0.4) 7.27%,
        rgba(255, 212, 216, 0.4) 105.33%
      );
    }
  }
}
</style>
